@page "/burnrate"

@using AntDesign
@using System.Text
@using FIOWeb.Models
@using FIOWeb.JsonPayloads
@using Newtonsoft.Json
@using CurrieTechnologies.Razor.Clipboard

@inject NavigationManager NavManager
@inject GlobalAppState GlobalAppState
@inject ClipboardService Clipboard
@inject IMatToaster Toaster

@implements IDisposable

<FIOWeb.Components.LoadingWrapper RequiresAuth="true" @bind-ProgressCount="ProgressCount" TotalProgress="1">
    @if (BurnRateModels == null && CannotSeeUsersData )
    {
        <h1>Unable to View Specified Users Data</h1> 
    }
    else 
    {
        <h1>Burn Rate - @ActiveUserName</h1>
        <MatIconButton Style="outline:0" Icon="refresh" OnClick="@(() => { _ = Refresh(); })"></MatIconButton>
        
        <FIOWeb.Components.UserOrGroup AllowancesRequired="@RequiredAllowances" @bind-CurrentUserName="ActiveUserName" UserNameSelectionChanged="@Refresh"/>

        <div style="width:100%">
            <div class="flex-container"style="display: flex; flex-flow: row wrap; justify-content: flex-start">
                <div style="margin-right: 10px; min-height: 100px; max-height:100px; padding: 10px 10px 10px 10px"><Checkbox Checked="@ShowHiddenConsumables" CheckedChange="@(() => {ShowHiddenConsumables = !ShowHiddenConsumables;})">Show Hidden Consumables</Checkbox><br/><br/><em>Click rows to disable/hide</em></div>
                <MatNumericUpDownField Style="width:150px; padding: 10px 10px 10px 10px" Label="Yellow Threshold"
                                       @bind-Value=@YellowThreshold
                                       DecimalPlaces=0
                                       Minimum=@ThresholdMin Maximum=@ThresholdMax>
                </MatNumericUpDownField>
                <div>&nbsp;</div>
                <MatNumericUpDownField Style="width:150px; padding: 10px 10px 10px 10px" Label="Red Threshold"
                                       @bind-Value=@RedThreshold
                                       DecimalPlaces=0
                                       Minimum=@ThresholdMin Maximum=@ThresholdMax>
                </MatNumericUpDownField>
            </div>
        </div>
        <Table DataSource="BurnRateModels"
            TreeChildren="item => (ShowHiddenConsumables ? item.Children : item.FilteredChildren)"
            PageSize="50"
            Size=@TableSize.Small
            TItem="BurnRateModel"
            OnRowClick="BurnRateTable_OnRowClick"
            Bordered="true">
            <Column Width="200" @bind-Field="@context.PlanetDisplayName" Title= "Planet" Sortable="true" SorterCompare="@((v1, v2) => string.CompareOrdinal(v1, v2))">
                <a href="" @onclick="@(() => { _ = CopyPlanetBufferCommandToClipboard(context.PlanetStorageId);})" @onclick:preventDefault>@context.PlanetDisplayName</a>
                @if (!string.IsNullOrWhiteSpace(context.PlanetDisplayName) )
                {
                    <Popover Placement="@Placement.RightTop" Title="">
                        <ContentTemplate>
                            Retrieval Time: @(context.LastUpdate.ToLocalTime())
                        </ContentTemplate>
                        <ChildContent>
                            <MatIcon style="transform:scale(0.6)" Icon="av_timer"/>    
                        </ChildContent>
                    </Popover>
                }
            </Column>
            <Column Width="100" @bind-Field="@context.Material" Title="Material" Sortable="false">
                <div style="color:@(GetFGColor(context))">@context.Material</div>
            </Column>
            <Column Width="75" TData="string" Title="Burn Rate" Sortable="false">
                <div style="color:@(GetFGColor(context))" hidden="@(context.BurnRate==null)">@context.BurnRateDisplay</div>
            </Column>
            <Column Width="125" TData="string" Title="Units" Sortable="false">
                <div style="color:@(GetFGColor(context))" hidden="@(context.UnitsOnPlanet==null)">@context.UnitsOnPlanetDisplay</div>
            </Column>
            <Column Width="75" TData="float?" @bind-Field="@context.DaysRemaining" Title="Days Remaining" Sortable="true">
                <div><span style="color:@(GetFGColor(context)); background-color:@(GetBackgroundColor(context))">@context.DaysRemainingDisplay</span></div>
            </Column>
            <Column Width="175" TData="string" Title="Units To Yellow" Sortable="false">
                <div style="color:@(GetFGColor(context))" >@((MarkupString)context.UnitsToGetToYellowDisplay)</div>
            </Column>
            <Column @bind-Field="@context.LastUpdate" Title="" Sortable="true">
                @{
                    string Reason = (context.LastUpdateCause == "WORKFORCE") ? "Workforce" : "Storage";
                    Reason += $" data was last updated <b>{context.LastUpdate.ToLocalTime()}</b>.<br/>";
                    Reason += "Open up a <code>BS</code> buffer and navigate to this base.";
                }
                @if ( context.LastUpdate.ToLocalTime() < DateTime.Now.AddDays(-7.0) && context.LastUpdate.ToLocalTime() > DateTime.Now.AddDays(-30.0) )
                {
                    <Popover Placement="@Placement.RightTop" Title="">
                        <ContentTemplate>
                            @((MarkupString)Reason)
                        </ContentTemplate>
                        <ChildContent>
                            <MatIcon style="transform:scale(0.75)" Icon="info"/>    
                        </ChildContent>
                    </Popover>
                }
                else if ( context.LastUpdate <= DateTime.UtcNow.AddDays(-30.0) )
                {
                    <Popover Placement="@Placement.RightTop" Title="">
                        <ContentTemplate>
                            @((MarkupString)Reason)
                        </ContentTemplate>
                        <ChildContent>
                            <MatIcon style="transform:scale(0.75)" Icon="warning"/>    
                        </ChildContent>
                    </Popover>
                }
                else if ( context.ConsumptionTime != null )
                {
                    <Popover Placement="@Placement.RightTop" Title="">
                        <ContentTemplate>
                            The time indicated is estimated consumption time.<br/>
                            If you do not leave your game logged in with FIOExtension running, it may be old/invalid.<br/>
                            <br/>
                        </ContentTemplate>
                        <ChildContent>
                            <span>Consumption: @(((DateTime)context.ConsumptionTime).ToLocalTime().ToString("t"))</span>
                            <MatIcon style="transform:scale(0.75)" Icon="info"/>    
                        </ChildContent>
                    </Popover>
                }
                else if ( context.Children.Count > 0 )
                {
                    <Popover Placement="@Placement.RightTop" Title="">
                        <ContentTemplate>
                            <p>
                                If you leave APEX logged in with the FIOExtension present, eventually it will receive<br/>
                                a <em>WORKFORCES_WORKFORCE_UPDATED</em> event. Once this happens, FIO tracks it as your<br/>
                                consumption time.
                            </p>
                        </ContentTemplate>
                        <ChildContent>
                            <span>Consumption: Unknown</span>
                            <MatIcon style="transform:scale(0.75)" Icon="info"/>    
                        </ChildContent>
                    </Popover>
                }
            </Column>
        </Table>
    }
</FIOWeb.Components.LoadingWrapper>
